=== Filters/Points/CMakeLists.txt ===
set(Module_SRCS
  vtkBoundedPointSource.cxx
  vtkEllipsoidalGaussianKernel.cxx
  vtkEuclideanClusterExtraction.cxx
  vtkExtractHierarchicalBins.cxx
  vtkExtractPointCloudPiece.cxx
  vtkExtractPoints.cxx
  vtkExtractSurface.cxx
  vtkFitImplicitFunction.cxx
  vtkGaussianKernel.cxx
  vtkGeneralizedKernel.cxx
  vtkHierarchicalBinningFilter.cxx
  vtkInterpolationKernel.cxx
  vtkLinearKernel.cxx
  vtkPCACurvatureEstimation.cxx
  vtkPCANormalEstimation.cxx
  vtkPointDensityFilter.cxx
  vtkPointCloudFilter.cxx
  vtkPointInterpolator.cxx
  vtkPointInterpolator2D.cxx
  vtkProbabilisticVoronoiKernel.cxx
  vtkRadiusOutlierRemoval.cxx
  vtkSPHInterpolator.cxx
  vtkSPHCubicKernel.cxx
  vtkSPHKernel.cxx
  vtkSPHQuarticKernel.cxx
  vtkSPHQuinticKernel.cxx
  vtkShepardKernel.cxx
  vtkSignedDistance.cxx
  vtkStatisticalOutlierRemoval.cxx
  vtkVoxelGrid.cxx
  vtkVoronoiKernel.cxx
  vtkWendlandQuinticKernel.cxx
  )

set_source_files_properties(
  vtkGeneralizedKernel.cxx
  vtkInterpolationKernel
  vtkPointCloudFilter
  ABSTRACT
  )

vtk_module_library(vtkFiltersPoints ${Module_SRCS})
