## vtk7 7.1.1%2Bdfsg1

=== debian/changelog ===
vtk7 (7.1.1+dfsg1-12+rb1) UNRELEASED; urgency=medium

  * update

 -- Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>  Tue, 19 Jan 2021 14:28:34 +0800

vtk7 (7.1.1+dfsg1-12) unstable; urgency=medium

  [ Emilio Pozuelo Monfort ]
  * Let libvtk7-qt-dev depend on libqt5opengl5-dev rather than on
    libqt5opengl5-desktop-dev, as it was done for the build-dep.
    This fixes the dependency on arm{el,hf} which have OpenGL ES.
    Closes: #915779.

 -- Gert Wollny <gewo@debian.org>  Mon, 17 Dec 2018 10:03:58 +0100

vtk7 (7.1.1+dfsg1-11) unstable; urgency=medium

  * Re-upload to unstable

 -- Gert Wollny <gewo@debian.org>  Tue, 04 Dec 2018 23:34:23 +0100

vtk7 (7.1.1+dfsg1-11~exp1) experimental; urgency=medium

  * d/control, rules: re-enable qt on armel/armhf, Closes: #915054
  * d/rules: Add -ffloat-store to buildflags on i386, 
    hopefully helps to fix #914817

 -- Gert Wollny <gewo@debian.org>  Sun, 02 Dec 2018 19:08:36 +0100

vtk7 (7.1.1+dfsg1-10) unstable; urgency=medium

  * d/rules: Correctly set BuildAllModules, Closes: #911793
  * d/p/110: fix build with python 3.7.1, Closes:  #914347
  * d/p/111: Correct shebangs and add patch description

 -- Gert Wollny <gewo@debian.org>  Fri, 23 Nov 2018 21:02:42 +0100

vtk7 (7.1.1+dfsg1-9) unstable; urgency=medium

  * d/control: Add mipsel to build archs for *-qt packages, 
    Closes: #913459

 -- Gert Wollny <gewo@debian.org>  Mon, 12 Nov 2018 17:48:00 +0100

vtk7 (7.1.1+dfsg1-8) unstable; urgency=medium

  * d/control: Remove QT deps from vtk-tcl on armhf/armel

 -- Gert Wollny <gewo@debian.org>  Mon, 29 Oct 2018 07:09:14 +0100

vtk7 (7.1.1+dfsg1-7) unstable; urgency=medium

  * d/control: Remove python3-vtk deps on QT on armhf armel

 -- Gert Wollny <gewo@debian.org>  Sun, 28 Oct 2018 19:16:48 +0100

vtk7 (7.1.1+dfsg1-6) unstable; urgency=medium

  * Upload to unstable

 -- Gert Wollny <gewo@debian.org>  Sun, 28 Oct 2018 09:09:12 +0100

vtk7 (7.1.1+dfsg1-6~exp1) experimental; urgency=medium

  * d/*: don't build QT packages on armel,armhf and disables 
         some things around it
  * d/vtk7.install: don't install the OglExtension parser, this 
         seems to relate to the disabled OpenGL render backend and
         not to the new OpenGL2 backend 

 -- Gert Wollny <gewo@debian.org>  Sat, 27 Oct 2018 11:45:02 +0200

vtk7 (7.1.1+dfsg1-5) unstable; urgency=medium

  * cmd fix dpkg   
    - Update standards to 4.2.1 (no changes)
    - remove expat license text from d/copyright
  * re-upload to unstable

 -- Gert Wollny <gewo@debian.org>  Sun, 09 Sep 2018 14:13:06 +0200

vtk7 (7.1.1+dfsg1-5~exp1) experimental; urgency=medium

  * d/rules: remove python3.5 symlink, Closes: #906181
  * d/control: Depend only on the default python3 version
  * d/control: remove obsolete x-python3-version tag
  * Upload to experimental because of python3-ubjson

 -- Gert Wollny <gewo@debian.org>  Sun, 26 Aug 2018 19:25:46 +0200

vtk7 (7.1.1+dfsg1-4) unstable; urgency=medium

  * d/control:build-dep on libqt5opengl5-desktop-dev Closes: #896100
  * d/rules: remove hard-coded MIP include path

 -- Gert Wollny <gewo@debian.org>  Sun, 22 Apr 2018 18:36:35 +0200

vtk7 (7.1.1+dfsg1-3) unstable; urgency=medium

  * Update autopkgtst to OpenGL2 interface
  * d/control: Remove Andy from uploaders

 -- Gert Wollny <gewo@debian.org>  Sun, 15 Apr 2018 16:37:32 +0200

vtk7 (7.1.1+dfsg1-2) unstable; urgency=medium

  * d/control: Add depenency on libglew-dev to -dev package

 -- Gert Wollny <gewo@debian.org>  Fri, 13 Apr 2018 12:15:49 +0200

vtk7 (7.1.1+dfsg1-1) unstable; urgency=medium

  * upload to unstable

 -- Gert Wollny <gewo@debian.org>  Thu, 12 Apr 2018 14:45:41 +0200

vtk7 (7.1.1+dfsg1-1~exp4) experimental; urgency=medium

  * [32f2e3c] d/control: Disable build on armel and armhf
  * [de17b61] d/python3-vtk7.install: Also install helpers

 -- Gert Wollny <gewo@debian.org>  Sun, 08 Apr 2018 20:14:40 +0200

vtk7 (7.1.1+dfsg1-1~exp3) experimental; urgency=medium

  * [3c45e93] d/p/fix_glew: Add patch to fix conflict between 
    glew and gles on arm

 -- Gert Wollny <gewo@debian.org>  Thu, 05 Apr 2018 18:55:21 +0200

vtk7 (7.1.1+dfsg1-1~exp2) experimental; urgency=medium

  * Initial release. (Closes: #810254)
    Thanks: Nico Schloemer for initial work and python3 packaging

 -- Gert Wollny <gewo@debian.org>  Sun, 01 Apr 2018 21:00:44 +0000
