## vtk7 7.1.1%2Bdfsg2

=== debian/changelog ===
vtk7 (7.1.1+dfsg2-8) unstable; urgency=medium

  * Team upload
  * Add patch to fix mysql8 build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Dec 2020 20:52:18 +0100

vtk7 (7.1.1+dfsg2-7) unstable; urgency=medium

  * Team upload
  * Fix maintainer address (Closes: #977390)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Dec 2020 18:57:56 +0100

vtk7 (7.1.1+dfsg2-6) unstable; urgency=medium

  * Team upload
  * debian/patches/581d9eb874b2b80a3fb21c739a96fa6f955ffb5e.patch:
    - another upstream cherry-pick for new freetype build failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Dec 2020 22:20:48 +0100

vtk7 (7.1.1+dfsg2-5) unstable; urgency=medium

  * Team upload
  * debian/patches/3edc0de2b04ae1e100c229e592d6b9fa94f2915a.patch:
    - cherry-pick and rebase upstream build fix for new freetype (Closes:
      #976976)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 11 Dec 2020 20:05:14 +0100

vtk7 (7.1.1+dfsg2-4) unstable; urgency=medium

  * Revert "d/p/114: Fix compilation with mysql" Closes: #955817
  * d/d/115: Handle gcc-10 in version check Closes: #957917
  * d/control: Move to compat level 11

 -- Gert Wollny <gewo@debian.org>  Sat, 25 Apr 2020 20:39:23 +0200

vtk7 (7.1.1+dfsg2-3) unstable; urgency=medium

  * d/control,rules: Support build without java, Closes: #947986
  * d/p/113 fix comparison with literal, Closes:#950539
  * d/p/114: Fix compilation with newer mysql

 -- Gert Wollny <gewo@debian.org>  Sat, 25 Apr 2020 15:53:00 +0200

vtk7 (7.1.1+dfsg2-2) unstable; urgency=medium

  * d/libvtk7-jni: Install into correct libdir, Closes: #950027

 -- Gert Wollny <gewo@debian.org>  Sun, 09 Feb 2020 16:52:05 +0100

vtk7 (7.1.1+dfsg2-1) unstable; urgency=medium

  * Upload to unstable, Closes:  #931944 

 -- Gert Wollny <gewo@debian.org>  Fri, 01 Nov 2019 09:19:22 +0100

vtk7 (7.1.1+dfsg2-1~exp1) experimental; urgency=medium

  [ Nico Schlömer ]
  * update broken debian/watch

  [ Gert Wollny ]
  * d/*: switch back to use bundled proj4, Closes: #931044
  * d/watch: Restrict to v7
  * Update tarball to contain proj4 
  * d/p/112: Add support for riscv64, Closes: #924611
  * d/libvtk-jni: install to /usr/lib/jni (Java Policy 2.4), 
    Closes: #930512
  * d/*: Change soname because of using embedded libproj4

 -- Gert Wollny <gewo@debian.org>  Sun, 25 Aug 2019 22:15:51 +0200
